/*

    ========== licence begin  GPL
    Copyright (c) 2005 SAP AG

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end

*/
#ifndef __OMS_SHAREDMEMALLOCATOR_HPP
#define __OMS_SHAREDMEMALLOCATOR_HPP

#include "gsp00.h"

class OMS_SharedMemAllocator {
public :
  OMS_SharedMemAllocator();
  inline void  *allocate(size_t sz);
  inline void  deallocate(void* pz);

  static void *allocateImpl(size_t sz);
  static void deallocateImpl(void *p);
private :
  tsp00_8ByteCounter m_sharedMemUsed;
};

/*----------------------------------------------------------------------*/

inline void* OMS_SharedMemAllocator::allocate(size_t sz) {
  return allocateImpl(sz);
}

/*----------------------------------------------------------------------*/

inline void OMS_SharedMemAllocator::deallocate(void *p) {
  deallocateImpl(p);
}

#endif //__OMS_SHAREDMEMALLOCATOR_HPP
